local composer = require( "composer" )
local setVariable, getVariable = composer.setVariable, composer.getVariable

local scene = composer.newScene()
 

-- create()
function scene:create( event )
    local sceneGroup = self.view
	
	
	local _H = display.contentHeight
	local _W = display.contentWidth
	local newMenuDataExample = {
		{
			name="Game",
			--there not need "id"
			items={
				{name="Font", id="GameFontGroup"},
				{name="Sound", id="GameSoundGroup"}
			}
		},
		{
			name="Chat",
			--there not need "id" 
			items={
				{name="Font", id="ChatFontGroup"},
				{name="Sound", id="ChatSoundGroup"}
			}
		},
		{
			name="OwnIcon",
			--there not need "id" 
			iconDir=system.ResourceDirectory,  -- OwnIconDir
			icon="own-icon.png", -- OwnIcon
			items={
				{name="own icon test", id="ownIconGroup"},
			}
		},
		{
			name="System",
			id="systemGroup", -- !!!! need "id" if empty items={}
			items={}
		}
	}
	
	local scrollOptions = {
		left=200,
		top=100,
		width = 230,
		height = 500,
		scrollHeight = 500,
		horizontalScrollDisabled=true,
		isBounceEnabled=false,
		hideBackground =true,
		hideScrollBar=true
	}
	
	
	local SubMenu = require("SubMenu")
	local Menu = SubMenu:Create(newMenuDataExample, scrollOptions)
	Menu:initialization(sceneGroup)
	local panel = display.newRect(sceneGroup, Menu.x + (Menu.width*0.5)-30, Menu.y, _W*0.6, Menu.height)
	panel.anchorX = 0
	panel:setFillColor(0,0,0)
	panel:toBack()
	local TestGameFontGroup = display.newText("test GameFontGroup", panel.x+(panel.width*0.25), panel.y, native.systemFont, 20)
	local TestGameSoundGroup = display.newText("test GameSoundGroup", panel.x+(panel.width*0.25), panel.y, native.systemFont, 20)
	local TestChatFontGroup = display.newText("test ChatFontGroup", panel.x+(panel.width*0.25), panel.y, native.systemFont, 20)
	local TestChatSoundGroup = display.newText("test ChatSoundGroup", panel.x+(panel.width*0.25), panel.y, native.systemFont, 20)
	local TestSystemGroup = display.newText("test systemGroup", panel.x+(panel.width*0.25), panel.y, native.systemFont, 20)
	Menu:add(TestGameFontGroup, "GameFontGroup")
	Menu:add(TestGameSoundGroup, "GameSoundGroup")
	Menu:add(TestChatFontGroup, "ChatFontGroup")
	Menu:add(TestChatSoundGroup, "ChatSoundGroup")
	Menu:add(TestSystemGroup, "systemGroup")
	--[[ 
	
		Menu:OpenSub(id, subID or nil)
		Menu:OpenSub(1) -- Auto open Game(Font)
		Menu:OpenSub(1,1) -- Auto open Game(Font)
		Menu:OpenSub(1,2) -- Auto open Game(Sound)
		Menu:OpenSub(2) -- Auto open Chat(Font)
		Menu:OpenSub(2,1) -- Auto open Chat(Font)
		Menu:OpenSub(2,2) -- Auto open Chat(Sound)
		Menu:OpenSub(3) -- Auto open System
	
	]]--
	Menu:OpenSub(1)
	
end
 
 
-- show()
function scene:show( event )
    local sceneGroup = self.view
    local phase = event.phase
 
    if ( phase == "will" ) then
	elseif ( phase == "did" ) then
	end
end
 
 
-- hide()
function scene:hide( event )
    local sceneGroup = self.view
    local phase = event.phase
 
    if ( phase == "will" ) then
    
    elseif ( phase == "did" ) then
    end
end
 
 
-- destroy()
function scene:destroy( event )
    local sceneGroup = self.view
    -- Code here runs prior to the removal of scene's view
 
end
 
 
-- -----------------------------------------------------------------------------------
-- Scene event function listeners
-- -----------------------------------------------------------------------------------
scene:addEventListener( "create", scene )
scene:addEventListener( "show", scene )
scene:addEventListener( "hide", scene )
scene:addEventListener( "destroy", scene )
-- -----------------------------------------------------------------------------------
 
return scene